import sqlite3
import xml.sax
from pony import orm

orm.set_sql_debug(True)
db = orm.Database()
db.bind(provider='sqlite', filename=":memory:", create_db=True)
#db.bind(provider='sqlite', filename="rh.db", create_db=True)

class Emp(db.Entity):
    id = orm.PrimaryKey(int,auto=True)
    name = orm.Optional(str)
    dept = orm.Optional(str)
    city = orm.Optional(str)
    supervisor = orm.Optional('Emp')
    supervised = orm.Set('Emp')
    def __str__(self):
        return "Emp(%d) %s"%(self.id,self.name)

db.generate_mapping(create_tables=True)

class TravahoHandler(xml.sax.ContentHandler):
    def __init__(self):
        self.emp = None
        self.reading_name = False

    def startDocument(self):
        pass

    def startElement(self, xml_name, xml_attrs):
        if xml_name == 'employe':
            e = Emp()
            if self.emp:
                e.supervisor = self.emp
            self.emp = e
        elif xml_name in ['nom']:
            self.reading_name = True
        elif xml_name == 'dep':
            self.emp.dept = xml_attrs['nom']
            self.emp.city = xml_attrs['ville']

    def characters(self, text):
        if self.reading_name:
            self.emp.name = text

    def endElement(self, xml_name):
        if xml_name == 'nom':
            self.reading_name = False
        if xml_name == 'employe':
            self.emp = self.emp.supervisor

    def endDocument(self):
        orm.commit()

parser = xml.sax.make_parser()
parser.setContentHandler(TravahoHandler())
with orm.db_session:
    parser.parse(open('emp.xml','r'))
